window.Gleam.initSearch([{"doc":"kirala_markdown","title":"kirala_markdown","content":"# kirala_markdown\n\nmarkdown parser and html renderer written in Gleam language ver 1.0.0.\nThis is a simple port from [kirala_bbmarkdown](https://github.com/Yasuo-Higano/kirala_bbmarkdown), which does pattern matching by string whereas bbmarkdown does binary pattern matching.\n\nbbmarkdown is about 25% faster than this, but this one also works with javascript target.\n\n## parse markdown\n```\nimport kirala/markdown/parser\n\nfn parse_markdown(markdown: String) {\n  let ast = parser.parse(1, bit_array.from_string(markdown))\n}\n```\n\n## markdown to html\n```\nimport kirala/markdown/html_renderer\n\nfn markdown_to_html(markdown: String) -&gt; String {\n  let html = html_renderer.convert(markdown)\n}\n```\n\n## example\n- https://github.com/Yasuo-Higano/example_gleam_markdown_server\n\n\n## build javascript target\npack_js.sh\n```\ngleam build --target javascript\nnpm install --save-exact --save-dev -g esbuild\nesbuild kirala_markdown/kirala_markdown.mjs --bundle --platform=node --outfile=./build/kirala_markdown-node.js\n```\n\n## Running in nodejs\n```\nnode\n\nmd = require(&quot;./build/kirala_markdown-node.js&quot;)\nmd.markdown_to_html(&quot;# Hello world&quot;)\n\n```\n","url":"index.html"},{"doc":"kirala/markdown/strfmt","title":"str","content":"pub fn str(value: a) -&gt; String\n\nSynonyms:\nkirala/markdown/strfmt.str\nkirala/markdown/strfmt str","url":"kirala/markdown/strfmt.html#str"},{"doc":"kirala/markdown/strfmt","title":"text","content":"pub fn text(strs: List(String)) -&gt; String\n\nSynonyms:\nkirala/markdown/strfmt.text\nkirala/markdown/strfmt text","url":"kirala/markdown/strfmt.html#text"},{"doc":"kirala/markdown/strfmt","title":"kirala/markdown/strfmt","content":"","url":"kirala/markdown/strfmt.html"},{"doc":"kirala/markdown/parser","title":"Align","content":"pub type Align {\n  AlignLeft\n  AlignRight\n  AlignCenter\n}\n\nAlignLeft\n\n\nAlignRight\n\n\nAlignCenter\n\n\nSynonyms:\nkirala/markdown/parser.Align\nkirala/markdown/parser Align","url":"kirala/markdown/parser.html#Align"},{"doc":"kirala/markdown/parser","title":"ListType","content":"pub type ListType {\n  StdList\n  OrderedList\n  CheckedList\n  UncheckedList\n}\n\nStdList\n\n\nOrderedList\n\n\nCheckedList\n\n\nUncheckedList\n\n\nSynonyms:\nkirala/markdown/parser.ListType\nkirala/markdown/parser ListType","url":"kirala/markdown/parser.html#ListType"},{"doc":"kirala/markdown/parser","title":"Token","content":"pub type Token {\n  Line(List(Token))\n  LineIndent(Int, List(Token))\n  Text(String)\n  Bold(Token)\n  Italic(Token)\n  StrikeThrough(Token)\n  MarkedText(Token)\n  InsertedText(Token)\n  Note(String, Token)\n  H(Int, Int, Token)\n  CodeBlock(String, String, String)\n  CodeSpan(String)\n  CodeLine(String)\n  BlockQuote(Int, Token)\n  ListItem(ListType, Int, Token)\n  Url(UrlData)\n  UrlLink(String, UrlData)\n  ImgLink(String, String, UrlData)\n  FootNote(String, Token)\n  FootNoteUrlDef(String, String, String)\n  Table(List(Token), List(Align), List(List(Token)))\n  DefinitionOf(Token)\n  Definition(List(Token))\n  DefinitionIs(String, Token)\n  HR\n}\n\nLine(List(Token))\n\n\nLineIndent(Int, List(Token))\n\n\nText(String)\n\n\nBold(Token)\n\n\nItalic(Token)\n\n\nStrikeThrough(Token)\n\n\nMarkedText(Token)\n\n\nInsertedText(Token)\n\n\nNote(String, Token)\n\n\nH(Int, Int, Token)\n\n\nCodeBlock(String, String, String)\n\n\nCodeSpan(String)\n\n\nCodeLine(String)\n\n\nBlockQuote(Int, Token)\n\n\nListItem(ListType, Int, Token)\n\n\nUrl(UrlData)\n\n\nUrlLink(String, UrlData)\n\n\nImgLink(String, String, UrlData)\n\n\nFootNote(String, Token)\n\n\nFootNoteUrlDef(String, String, String)\n\n\nTable(List(Token), List(Align), List(List(Token)))\n\n\nDefinitionOf(Token)\n\n\nDefinition(List(Token))\n\n\nDefinitionIs(String, Token)\n\n\nHR\n\n\nSynonyms:\nkirala/markdown/parser.Token\nkirala/markdown/parser Token","url":"kirala/markdown/parser.html#Token"},{"doc":"kirala/markdown/parser","title":"TokenRes","content":"pub type TokenRes {\n  TokenRes(Token, String)\n}\n\nTokenRes(Token, String)\n\n\nSynonyms:\nkirala/markdown/parser.TokenRes\nkirala/markdown/parser TokenRes","url":"kirala/markdown/parser.html#TokenRes"},{"doc":"kirala/markdown/parser","title":"UrlData","content":"pub type UrlData {\n  UrlPlain(String)\n  UrlFootNote(String)\n}\n\nUrlPlain(String)\n\n\nUrlFootNote(String)\n\n\nSynonyms:\nkirala/markdown/parser.UrlData\nkirala/markdown/parser UrlData","url":"kirala/markdown/parser.html#UrlData"},{"doc":"kirala/markdown/parser","title":"parse","content":"pub fn parse(lineno: Int, src: String) -&gt; TokenRes\n\nSynonyms:\nkirala/markdown/parser.parse\nkirala/markdown/parser parse","url":"kirala/markdown/parser.html#parse"},{"doc":"kirala/markdown/parser","title":"parse_all","content":"pub fn parse_all(src: String) -&gt; List(Token)\n\nSynonyms:\nkirala/markdown/parser.parse_all\nkirala/markdown/parser parse_all","url":"kirala/markdown/parser.html#parse_all"},{"doc":"kirala/markdown/parser","title":"pop_grapheme","content":"pub fn pop_grapheme(src: String) -&gt; #(String, String)\n\nSynonyms:\nkirala/markdown/parser.pop_grapheme\nkirala/markdown/parser pop_grapheme","url":"kirala/markdown/parser.html#pop_grapheme"},{"doc":"kirala/markdown/parser","title":"ret_string","content":"pub fn ret_string(bitstr: String) -&gt; String\n\nSynonyms:\nkirala/markdown/parser.ret_string\nkirala/markdown/parser ret_string","url":"kirala/markdown/parser.html#ret_string"},{"doc":"kirala/markdown/parser","title":"ret_string_trim","content":"pub fn ret_string_trim(bitstr: String) -&gt; String\n\nSynonyms:\nkirala/markdown/parser.ret_string_trim\nkirala/markdown/parser ret_string_trim","url":"kirala/markdown/parser.html#ret_string_trim"},{"doc":"kirala/markdown/parser","title":"kirala/markdown/parser","content":"","url":"kirala/markdown/parser.html"},{"doc":"kirala/markdown/html_renderer","title":"convert","content":"pub fn convert(src: String) -&gt; String\n\nSynonyms:\nkirala/markdown/html_renderer.convert\nkirala/markdown/html_renderer convert","url":"kirala/markdown/html_renderer.html#convert"},{"doc":"kirala/markdown/html_renderer","title":"convert_bytes","content":"pub fn convert_bytes(bytes: String) -&gt; String\n\nSynonyms:\nkirala/markdown/html_renderer.convert_bytes\nkirala/markdown/html_renderer convert_bytes","url":"kirala/markdown/html_renderer.html#convert_bytes"},{"doc":"kirala/markdown/html_renderer","title":"convert_bytes_digest","content":"pub fn convert_bytes_digest(bytes: String) -&gt; String\n\nSynonyms:\nkirala/markdown/html_renderer.convert_bytes_digest\nkirala/markdown/html_renderer convert_bytes_digest","url":"kirala/markdown/html_renderer.html#convert_bytes_digest"},{"doc":"kirala/markdown/html_renderer","title":"convert_bytes_outline","content":"pub fn convert_bytes_outline(bytes: String) -&gt; String\n\nSynonyms:\nkirala/markdown/html_renderer.convert_bytes_outline\nkirala/markdown/html_renderer convert_bytes_outline","url":"kirala/markdown/html_renderer.html#convert_bytes_outline"},{"doc":"kirala/markdown/html_renderer","title":"convert_digest","content":"pub fn convert_digest(src: String) -&gt; String\n\nSynonyms:\nkirala/markdown/html_renderer.convert_digest\nkirala/markdown/html_renderer convert_digest","url":"kirala/markdown/html_renderer.html#convert_digest"},{"doc":"kirala/markdown/html_renderer","title":"convert_outline","content":"pub fn convert_outline(src: String) -&gt; String\n\nSynonyms:\nkirala/markdown/html_renderer.convert_outline\nkirala/markdown/html_renderer convert_outline","url":"kirala/markdown/html_renderer.html#convert_outline"},{"doc":"kirala/markdown/html_renderer","title":"convert_tokens_","content":"pub fn convert_tokens_(\n  tokens: List(Token),\n  symbols: Dict(String, String),\n) -&gt; String\n\nSynonyms:\nkirala/markdown/html_renderer.convert_tokens_\nkirala/markdown/html_renderer convert_tokens_","url":"kirala/markdown/html_renderer.html#convert_tokens_"},{"doc":"kirala/markdown/html_renderer","title":"emit","content":"pub fn emit(symbols: Dict(String, String), t: Token) -&gt; String\n\nSynonyms:\nkirala/markdown/html_renderer.emit\nkirala/markdown/html_renderer emit","url":"kirala/markdown/html_renderer.html#emit"},{"doc":"kirala/markdown/html_renderer","title":"emit_text","content":"pub fn emit_text(\n  symbols: Dict(String, String),\n  t: Token,\n) -&gt; String\n\nSynonyms:\nkirala/markdown/html_renderer.emit_text\nkirala/markdown/html_renderer emit_text","url":"kirala/markdown/html_renderer.html#emit_text"},{"doc":"kirala/markdown/html_renderer","title":"html_encode","content":"pub fn html_encode(src: String) -&gt; String\n\nSynonyms:\nkirala/markdown/html_renderer.html_encode\nkirala/markdown/html_renderer html_encode","url":"kirala/markdown/html_renderer.html#html_encode"},{"doc":"kirala/markdown/html_renderer","title":"html_encode_","content":"pub fn html_encode_(src: String, acc: String) -&gt; String\n\nSynonyms:\nkirala/markdown/html_renderer.html_encode_\nkirala/markdown/html_renderer html_encode_","url":"kirala/markdown/html_renderer.html#html_encode_"},{"doc":"kirala/markdown/html_renderer","title":"kirala/markdown/html_renderer","content":"","url":"kirala/markdown/html_renderer.html"},{"doc":"kirala/peasy","title":"get_env","content":"pub fn get_env(key: String, default_value: String) -&gt; String\n\nSynonyms:\nkirala/peasy.get_env\nkirala/peasy get_env","url":"kirala/peasy.html#get_env"},{"doc":"kirala/peasy","title":"get_env_int","content":"pub fn get_env_int(key: String, default_value: Int) -&gt; Int\n\nSynonyms:\nkirala/peasy.get_env_int\nkirala/peasy get_env_int","url":"kirala/peasy.html#get_env_int"},{"doc":"kirala/peasy","title":"http_get_text","content":"pub fn http_get_text(\n  url: String,\n  headers: List(#(String, String)),\n) -&gt; Result(String, String)\n\nSynonyms:\nkirala/peasy.http_get_text\nkirala/peasy http_get_text","url":"kirala/peasy.html#http_get_text"},{"doc":"kirala/peasy","title":"now","content":"pub fn now() -&gt; Float\n\nSynonyms:\nkirala/peasy.now\nkirala/peasy now","url":"kirala/peasy.html#now"},{"doc":"kirala/peasy","title":"print","content":"pub fn print(val: a) -&gt; String\n\nSynonyms:\nkirala/peasy.print\nkirala/peasy print","url":"kirala/peasy.html#print"},{"doc":"kirala/peasy","title":"println","content":"pub fn println(val: a) -&gt; String\n\nSynonyms:\nkirala/peasy.println\nkirala/peasy println","url":"kirala/peasy.html#println"},{"doc":"kirala/peasy","title":"read_file","content":"pub fn read_file(filepath: String) -&gt; Result(BitArray, String)\n\nSynonyms:\nkirala/peasy.read_file\nkirala/peasy read_file","url":"kirala/peasy.html#read_file"},{"doc":"kirala/peasy","title":"read_text_file","content":"pub fn read_text_file(filepath: String) -&gt; Result(String, String)\n\nSynonyms:\nkirala/peasy.read_text_file\nkirala/peasy read_text_file","url":"kirala/peasy.html#read_text_file"},{"doc":"kirala/peasy","title":"readline","content":"pub fn readline(prompt: String) -&gt; String\n\nSynonyms:\nkirala/peasy.readline\nkirala/peasy readline","url":"kirala/peasy.html#readline"},{"doc":"kirala/peasy","title":"run_test","content":"pub fn run_test() -&gt; String\n\nSynonyms:\nkirala/peasy.run_test\nkirala/peasy run_test","url":"kirala/peasy.html#run_test"},{"doc":"kirala/peasy","title":"show","content":"pub fn show(val: a) -&gt; String\n\nSynonyms:\nkirala/peasy.show\nkirala/peasy show","url":"kirala/peasy.html#show"},{"doc":"kirala/peasy","title":"kirala/peasy","content":"","url":"kirala/peasy.html"}]);